pcl::poisson::Polynomial< Degree > Class Template Reference

`#include <pcl/surface/3rdparty/poisson4/polynomial.h>`

## Public Member Functions

| Polynomial (void)
template<int Degree2>
| Polynomial (const Polynomial< Degree2 > &P)
double | operator() (double t) const
double | integral (double tMin, double tMax) const
int | operator== (const Polynomial &p) const
int | operator!= (const Polynomial &p) const
int | isZero (void) const
void | setZero (void)
template<int Degree2>
Polynomial & | operator= (const Polynomial< Degree2 > &p)
Polynomial & | operator+= (const Polynomial &p)
Polynomial & | operator-= (const Polynomial &p)
Polynomial | operator- (void) const
Polynomial | operator+ (const Polynomial &p) const
Polynomial | operator- (const Polynomial &p) const
template<int Degree2>
Polynomial< Degree+Degree2 > | operator* (const Polynomial< Degree2 > &p) const
Polynomial & | operator+= (double s)
Polynomial & | operator-= (double s)
Polynomial & | operator*= (double s)
Polynomial & | operator/= (double s)
Polynomial | operator+ (double s) const
Polynomial | operator- (double s) const
Polynomial | operator* (double s) const
Polynomial | operator/ (double s) const
Polynomial | scale (double s) const
Polynomial | shift (double t) const
Polynomial< Degree-1 > | derivative (void) const
Polynomial< Degree+1 > | integral (void) const
void | printnl (void) const
Polynomial & | addScaled (const Polynomial &p, double scale)
void | getSolutions (double c, std::vector< double > &roots, double EPS) const
template<int Degree2>
Polynomial< Degree > & | operator= (const Polynomial< Degree2 > &p)
template<>
double | operator() (double t) const
template<>
double | operator() (double t) const
template<>
double | operator() (double t) const
template<>
Polynomial< 0 > | BSplineComponent (int i)

## Static Public Member Functions

static void | Negate (const Polynomial &in, Polynomial &out)
static void | Subtract (const Polynomial &p1, const Polynomial &p2, Polynomial &q)
static void | Scale (const Polynomial &p, double w, Polynomial &q)
static void | AddScaled (const Polynomial &p1, double w1, const Polynomial &p2, double w2, Polynomial &q)
static void | AddScaled (const Polynomial &p1, const Polynomial &p2, double w2, Polynomial &q)
static void | AddScaled (const Polynomial &p1, double w1, const Polynomial &p2, Polynomial &q)
static Polynomial | BSplineComponent (int i)

## Public Attributes

double | coefficients [Degree+1]

## Detailed Description

### template<int Degree>
class pcl::poisson::Polynomial< Degree >

Definition at line 40 of file polynomial.h.

## Constructor & Destructor Documentation

template<int Degree>

pcl::poisson::Polynomial< Degree >::Polynomial | ( | void |  | ) |

Definition at line 45 of file polynomial.hpp.

template<int Degree>
template<int Degree2>

pcl::poisson::Polynomial< Degree >::Polynomial | ( | const Polynomial< Degree2 > & | P | ) |

Definition at line 48 of file polynomial.hpp.

References pcl::poisson::Polynomial< Degree >::coefficients.

## Member Function Documentation

template<int Degree>

Polynomial< Degree > & pcl::poisson::Polynomial< Degree >::addScaled | ( | const Polynomial< Degree > & | p,
|  | double | scale
| ) |  |

Definition at line 119 of file polynomial.hpp.

References pcl::poisson::Polynomial< Degree >::coefficients.

template<int Degree>

void pcl::poisson::Polynomial< Degree >::AddScaled | ( | const Polynomial< Degree > & | p1,
|  | double | w1,
|  | const Polynomial< Degree > & | p2,
|  | double | w2,
|  | Polynomial< Degree > & | q
| ) |  |

static

Definition at line 150 of file polynomial.hpp.

References pcl::poisson::Polynomial< Degree >::coefficients.

template<int Degree>

void pcl::poisson::Polynomial< Degree >::AddScaled | ( | const Polynomial< Degree > & | p1,
|  | const Polynomial< Degree > & | p2,
|  | double | w2,
|  | Polynomial< Degree > & | q
| ) |  |

static

Definition at line 158 of file polynomial.hpp.

References pcl::poisson::Polynomial< Degree >::coefficients.

template<int Degree>

void pcl::poisson::Polynomial< Degree >::AddScaled | ( | const Polynomial< Degree > & | p1,
|  | double | w1,
|  | const Polynomial< Degree > & | p2,
|  | Polynomial< Degree > & | q
| ) |  |

static

Definition at line 154 of file polynomial.hpp.

References pcl::poisson::Polynomial< Degree >::coefficients.

template<int Degree>

Polynomial< Degree > pcl::poisson::Polynomial< Degree >::BSplineComponent | ( | int | i | ) |

static

Definition at line 307 of file polynomial.hpp.

References pcl::poisson::Polynomial< Degree >::coefficients, and pcl::poisson::Polynomial< Degree >::integral().

Referenced by pcl::poisson::SetBSplineElementIntegrals().

template<>

Polynomial< 0 > pcl::poisson::Polynomial< 0 >::BSplineComponent | ( | int | i | ) |

Definition at line 300 of file polynomial.hpp.

References pcl::poisson::Polynomial< Degree >::coefficients.

template<int Degree>

Polynomial< Degree-1 > pcl::poisson::Polynomial< Degree >::derivative | ( | void |  | ) | const

Definition at line 64 of file polynomial.hpp.

References pcl::poisson::Polynomial< Degree >::coefficients.

template<int Degree>

void pcl::poisson::Polynomial< Degree >::getSolutions | ( | double | c,
|  | std::vector< double > & | roots,
|  | double | EPS
| ) |  | const

Definition at line 272 of file polynomial.hpp.

References pcl::poisson::Factor().

Referenced by pcl::poisson::Octree< Degree >::GetIsoValue(), and pcl::poisson::PPolynomial< Degree >::getSolutions().

template<int Degree>

double pcl::poisson::Polynomial< Degree >::integral | ( | double | tMin,
|  | double | tMax
| ) |  | const

Definition at line 87 of file polynomial.hpp.

Referenced by pcl::poisson::Polynomial< Degree >::BSplineComponent(), and pcl::poisson::PPolynomial< Degree >::MovingAverage().

template<int Degree>

Polynomial< Degree+1 > pcl::poisson::Polynomial< Degree >::integral | ( | void |  | ) | const

Definition at line 71 of file polynomial.hpp.

References pcl::poisson::Polynomial< Degree >::coefficients.

template<int Degree>

int pcl::poisson::Polynomial< Degree >::isZero | ( | void |  | ) | const

Definition at line 111 of file polynomial.hpp.

template<int Degree>

void pcl::poisson::Polynomial< Degree >::Negate | ( | const Polynomial< Degree > & | in,
|  | Polynomial< Degree > & | out
| ) |  |

static

Definition at line 167 of file polynomial.hpp.

References pcl::poisson::Polynomial< Degree >::coefficients.

template<int Degree>

int pcl::poisson::Polynomial< Degree >::operator!= | ( | const Polynomial< Degree > & | p | ) | const

Definition at line 106 of file polynomial.hpp.

References pcl::poisson::Polynomial< Degree >::coefficients.

template<int Degree>

double pcl::poisson::Polynomial< Degree >::operator() | ( | double | t | ) | const

Definition at line 81 of file polynomial.hpp.

template<>

double pcl::poisson::Polynomial< 0 >::operator() | ( | double | t | ) | const

Definition at line 77 of file polynomial.hpp.

template<>

double pcl::poisson::Polynomial< 1 >::operator() | ( | double | t | ) | const

Definition at line 78 of file polynomial.hpp.

template<>

double pcl::poisson::Polynomial< 2 >::operator() | ( | double | t | ) | const

Definition at line 79 of file polynomial.hpp.

template<int Degree>
template<int Degree2>

Polynomial< Degree+Degree2 > pcl::poisson::Polynomial< Degree >::operator* | ( | const Polynomial< Degree2 > & | p | ) | const

Definition at line 180 of file polynomial.hpp.

References pcl::poisson::Polynomial< Degree >::coefficients.

template<int Degree>

Polynomial< Degree > pcl::poisson::Polynomial< Degree >::operator* | ( | double | s | ) | const

Definition at line 225 of file polynomial.hpp.

References pcl::poisson::Polynomial< Degree >::coefficients.

template<int Degree>

Polynomial< Degree > & pcl::poisson::Polynomial< Degree >::operator*= | ( | double | s | ) |

Definition at line 199 of file polynomial.hpp.

template<int Degree>

Polynomial< Degree > pcl::poisson::Polynomial< Degree >::operator+ | ( | const Polynomial< Degree > & | p | ) | const

Definition at line 134 of file polynomial.hpp.

References pcl::poisson::Polynomial< Degree >::coefficients.

template<int Degree>

Polynomial< Degree > pcl::poisson::Polynomial< Degree >::operator+ | ( | double | s | ) | const

Definition at line 211 of file polynomial.hpp.

References pcl::poisson::Polynomial< Degree >::coefficients.

template<int Degree>

Polynomial< Degree > & pcl::poisson::Polynomial< Degree >::operator+= | ( | const Polynomial< Degree > & | p | ) |

Definition at line 124 of file polynomial.hpp.

References pcl::poisson::Polynomial< Degree >::coefficients.

template<int Degree>

Polynomial< Degree > & pcl::poisson::Polynomial< Degree >::operator+= | ( | double | s | ) |

Definition at line 187 of file polynomial.hpp.

template<int Degree>

Polynomial< Degree > pcl::poisson::Polynomial< Degree >::operator- | ( | void |  | ) | const

Definition at line 173 of file polynomial.hpp.

References pcl::poisson::Polynomial< Degree >::coefficients.

template<int Degree>

Polynomial< Degree > pcl::poisson::Polynomial< Degree >::operator- | ( | const Polynomial< Degree > & | p | ) | const

Definition at line 140 of file polynomial.hpp.

References pcl::poisson::Polynomial< Degree >::coefficients.

template<int Degree>

Polynomial< Degree > pcl::poisson::Polynomial< Degree >::operator- | ( | double | s | ) | const

Definition at line 218 of file polynomial.hpp.

References pcl::poisson::Polynomial< Degree >::coefficients.

template<int Degree>

Polynomial< Degree > & pcl::poisson::Polynomial< Degree >::operator-= | ( | const Polynomial< Degree > & | p | ) |

Definition at line 129 of file polynomial.hpp.

References pcl::poisson::Polynomial< Degree >::coefficients.

template<int Degree>

Polynomial< Degree > & pcl::poisson::Polynomial< Degree >::operator-= | ( | double | s | ) |

Definition at line 193 of file polynomial.hpp.

template<int Degree>

Polynomial< Degree > pcl::poisson::Polynomial< Degree >::operator/ | ( | double | s | ) | const

Definition at line 232 of file polynomial.hpp.

References pcl::poisson::Polynomial< Degree >::coefficients.

template<int Degree>

Polynomial< Degree > & pcl::poisson::Polynomial< Degree >::operator/= | ( | double | s | ) |

Definition at line 205 of file polynomial.hpp.

template<int Degree>
template<int Degree2>

Polynomial& pcl::poisson::Polynomial< Degree >::operator= | ( | const Polynomial< Degree2 > & | p | ) |

template<int Degree>
template<int Degree2>

Polynomial<Degree>& pcl::poisson::Polynomial< Degree >::operator= | ( | const Polynomial< Degree2 > & | p | ) |

Definition at line 56 of file polynomial.hpp.

References pcl::poisson::Polynomial< Degree >::coefficients.

template<int Degree>

int pcl::poisson::Polynomial< Degree >::operator== | ( | const Polynomial< Degree > & | p | ) | const

Definition at line 101 of file polynomial.hpp.

References pcl::poisson::Polynomial< Degree >::coefficients.

template<int Degree>

void pcl::poisson::Polynomial< Degree >::printnl | ( | void |  | ) | const

Definition at line 264 of file polynomial.hpp.

Referenced by pcl::poisson::PPolynomial< Degree >::printnl().

template<int Degree>

Polynomial< Degree > pcl::poisson::Polynomial< Degree >::scale | ( | double | s | ) | const

Definition at line 239 of file polynomial.hpp.

References pcl::poisson::Polynomial< Degree >::coefficients.

template<int Degree>

void pcl::poisson::Polynomial< Degree >::Scale | ( | const Polynomial< Degree > & | p,
|  | double | w,
|  | Polynomial< Degree > & | q
| ) |  |

static

Definition at line 146 of file polynomial.hpp.

References pcl::poisson::Polynomial< Degree >::coefficients.

template<int Degree>

void pcl::poisson::Polynomial< Degree >::setZero | ( | void |  | ) |

Definition at line 116 of file polynomial.hpp.

Referenced by pcl::poisson::PPolynomial< Degree >::getSolutions().

template<int Degree>

Polynomial< Degree > pcl::poisson::Polynomial< Degree >::shift | ( | double | t | ) | const

Definition at line 250 of file polynomial.hpp.

References pcl::poisson::Polynomial< Degree >::coefficients.

Referenced by pcl::poisson::PPolynomial< Degree >::MovingAverage().

template<int Degree>

void pcl::poisson::Polynomial< Degree >::Subtract | ( | const Polynomial< Degree > & | p1,
|  | const Polynomial< Degree > & | p2,
|  | Polynomial< Degree > & | q
| ) |  |

static

Definition at line 163 of file polynomial.hpp.

References pcl::poisson::Polynomial< Degree >::coefficients.

## Member Data Documentation

template<int Degree>

double pcl::poisson::Polynomial< Degree >::coefficients[Degree+1]

Definition at line 42 of file polynomial.h.

Referenced by pcl::poisson::Polynomial< Degree >::addScaled(), pcl::poisson::Polynomial< Degree >::AddScaled(), pcl::poisson::Polynomial< Degree >::BSplineComponent(), pcl::poisson::Polynomial< Degree >::derivative(), pcl::poisson::Octree< Degree >::GetIsoValue(), pcl::poisson::Polynomial< Degree >::integral(), pcl::poisson::Polynomial< Degree >::Negate(), pcl::poisson::Polynomial< Degree >::operator!=(), pcl::poisson::Polynomial< Degree >::operator*(), pcl::poisson::Polynomial< Degree >::operator+(), pcl::poisson::Polynomial< Degree >::operator+=(), pcl::poisson::Polynomial< Degree >::operator-(), pcl::poisson::Polynomial< Degree >::operator-=(), pcl::poisson::Polynomial< Degree >::operator/(), pcl::poisson::Polynomial< Degree >::operator=(), pcl::poisson::Polynomial< Degree >::operator==(), pcl::poisson::Polynomial< Degree >::Polynomial(), pcl::poisson::Polynomial< Degree >::scale(), pcl::poisson::Polynomial< Degree >::Scale(), pcl::poisson::Polynomial< Degree >::shift(), and pcl::poisson::Polynomial< Degree >::Subtract().

The documentation for this class was generated from the following files:

- /build/pcl-0nnAvv/pcl-1.7.2/surface/include/pcl/surface/3rdparty/poisson4/polynomial.h
- /build/pcl-0nnAvv/pcl-1.7.2/surface/include/pcl/surface/3rdparty/poisson4/polynomial.hpp